<template>
	<div class="flex items-left w-full flex-col">
		<MkHorizontal class="mt-0 md:mt-2 mx-4" />
		<div v-if="FEATURE_GIFT" class="flex justify-between w-full mb-10 md:mb-6 lg:mb-8 px-2 md:px-4">
			<MkCheck radio-title="This is a gift" :checked="value" @change="isGift" />
			<MkGiftIcon />
		</div>
		<MkDiscount v-if="DISCOUNT_PRICE" class="mb-8 md:mb-6 lg:mb-8" />
		<div class="flex justify-between w-full mb-8 px-2 md:px-4 font-primary-font-bold">
			<p>Total</p>
			<p>{{ currencyDisplay }}{{ TOTAL_PRICE | centsToDollars | zeroDisplay | formatPrice }}</p>
		</div>
		<!-- <p class="font-primary-font-light text-center md:text-left lg:text-center text-sm mb-10 px-2 md:px-4">Starting at 0% APR at $45/mo with <MkAffirmLogo class="inline-block px-0.5 pt-0.5" /> <span class="font-primary-font-regular lg:font-primary-font-bold cursor-pointer block lg:inline-block mt-1 md:mt-2 lg:mt-0" @click="tealiumClick()">Learn more</span></p> -->
		<MkAffirmPrice v-if="FEATURE_AFFIRM" class="mb-10 px-2 md:px-4" :total-price="TOTAL_PRICE" page-type="cart" />
		<MkSecondaryButton
			:loading="loading"
			class="mb-8 md:mb-6 lg:mb-10 w-full flex justify-center px-2 md:px-4"
			button-title="Checkout"
			mksecondary-width="w-full"
			@click="submit()"
			@keypress.enter="submit()"
		/>
		<p class="font-primary-font-light text-center text-sm px-2 md:px-4">
			{{ isEurope ? 'VAT' : 'Taxes' }} and shipping calculated at checkout.
		</p>
	</div>
</template>
<script>
import { mapState } from 'vuex';
import MkSecondaryButton from '~/components/D2C/atoms/MkSecondaryButton.vue';
import MkCheck from '~/components/D2C/atoms/MkCheck.vue';
import MkGiftIcon from '~/components/D2C/atoms/MkGiftIcon.vue';
import MkDiscount from '~/components/D2C/atoms/MkDiscount.vue';
import MkHorizontal from '~/components/D2C/atoms/MkHorizontal.vue';
import MkAffirmPrice from '~/components/D2C/molecules/MkAffirmPrice.vue';
export default {
	name: 'MkPromoCard',
	components: {
		MkSecondaryButton,
		MkCheck,
		MkGiftIcon,
		MkDiscount,
		MkHorizontal,
		MkAffirmPrice,
	},
	props: {},
	data() {
		return {
			value: false,
			loading: false,
		};
	},
	computed: {
		...mapState(['currencyDisplay', 'isEurope']),
		...mapState('CART_STORE', ['DISCOUNT_PRICE', 'LINE_ITEMS', 'TOTAL_PRICE', 'CART_LINE_ITEMS_TEALIUM', 'GIFT']),
		...mapState('USER_STORE', ['CUSTOMER_DETAILS_D2C_TEALIUM']),
		...mapState('CHECKOUT_STORE', ['FEATURE_GIFT', 'FEATURE_AFFIRM']),
	},
	mounted() {
		this.value = this.GIFT;
	},
	methods: {
		submit() {
			this.checkoutClickTealium();
			this.$router.push('/D2C/checkout');
			this.$store.dispatch('MK_CART_STORE/TOGGLE_SIDE_CART', 'HIDE');
		},
		async isGift(value) {
			this.$store.commit('CHECKOUT_STORE/TOGGLE_PAGE_SPINNER');
			this.value = !value;
			const $data = {
				action: 'GIFT',
				gift: this.value,
			};
			await this.$store.dispatch('CART_STORE/UPDATE_CART_ACTION', $data);
			this.$store.commit('CHECKOUT_STORE/TOGGLE_PAGE_SPINNER');
			this.giftTealium(this.value ? 'clicked_gift_on' : 'clicked_gift_off', this.value);
		},
		giftTealium(key, value) {
			const customerDetails = this.$store.state.USER_STORE.CUSTOMER_DETAILS_D2C_TEALIUM;
			const tealiumPayload = {
				event_category: 'Gift Purchase',
				gift_purchase: value,
				cart_product_id: [...new Set(this.LINE_ITEMS.map((x) => x.productId))],
				cart_product_quantity: [...new Set(this.LINE_ITEMS.map((x) => x.quantity.toFixed(0) || '1'))],
				cart_product_sku: [...new Set(this.LINE_ITEMS.map((x) => x.variant.sku))],
				cart_total_items: this.LINE_ITEMS.length.toFixed(0),
				cart_total_value: this.$root.$utility.centsToDollarsConvert(this.TOTAL_PRICE),
				cart_discount: [this.$root.$utility.centsToDollarsConvert(this.DISCOUNT_PRICE)],
				event_value: [this.$root.$utility.centsToDollarsConvert(this.TOTAL_PRICE)],
				...customerDetails,
			};
			const listPriceArray = [];
			const productListPrice = [...new Set(this.LINE_ITEMS.map((x) => x.price))];
			productListPrice.forEach((el) => {
				if (el.value) {
					listPriceArray.push(this.$root.$utility.centsToDollarsConvert(el.value.centAmount));
				}
			});
			tealiumPayload.cart_product_price = listPriceArray;
			tealiumPayload.cart_product_list_price = listPriceArray;
			tealiumPayload.event_action =
				key === 'clicked_gift_on' ? 'Checked sidecart gift box' : 'Un-checked sidecart gift box';
			this.$root.$telium.setTealiumPayload(key, tealiumPayload);
		},
		checkoutClickTealium() {
			this.$root.$utility.checkoutTealium(
				this,
				'begin_checkout_click',
				'Clicked Begin Checkout',
				'Checkout',
				'Cart',
				this.CART_LINE_ITEMS_TEALIUM,
				this.CUSTOMER_DETAILS_D2C_TEALIUM
			);
		},
	},
};
</script>
